Skip post-test checks if not all unit tests are run.
[libdcp.git] / run / tests
index 4748927f311ebaa82e8931e49f5302a925188f5e..638b1d612ded3d5d04b538a274c9671a619cd945 100755 (executable)
--- a/run/tests
+++ b/run/tests
@@ -12,7 +12,7 @@ dcpinfo=build/tools/dcpinfo
 export LD_LIBRARY_PATH=build/src:/home/c.hetherington/lib:$LD_LIBRARY_PATH
 
 # Make sure we have the required tools
-for c in xmlsec1 xmldiff; do
+for c in xmlsec1 xmldiff xmllint; do
   hash $c 2>/dev/null || { echo >&2 "$c required but not found; aborting"; exit 1; }
 done
 
@@ -22,18 +22,25 @@ if [ "$1" == "--debug" ]; then
     gdb --args $work/tests $private $*
 elif [ "$1" == "--valgrind" ]; then
     shift
-    valgrind --tool="memcheck" $work/tests $private
+    valgrind --tool="memcheck" $work/tests $private $*
 elif [ "$1" == "--callgrind" ]; then
     shift
     valgrind --tool="callgrind" $work/tests $private $*
 else
-    $work/tests $* -- $private
+    # This gives a warning from newer boost versions but doing it
+    # as $work/tests $* -- $private fails on older boost versions.
+    $work/tests $private $*
     if [ "$?" != "0" ]; then
        echo "FAIL: unit tests"
         exit 1
     fi
 fi
 
+if [ "$*" != "" ]; then
+    echo "Skipping post-test checks as not all unit tests were run."
+    exit 0
+fi
+
 # Check a MXF written by the unit tests
 diff $work/baz/video1.mxf $work/baz/video2.mxf
 if [ "$?" != "0" ]; then
@@ -89,7 +96,7 @@ fi
 rm -f $work/info.log
 for d in `find $private/metadata -mindepth 1 -maxdepth 1 -type d | sort -f -d`; do
     if [ `basename $d` != ".git" ]; then
-        $dcpinfo --ignore-missing-assets -k -s $d >> $work/info.log
+        $dcpinfo --ignore-missing-assets -s $d >> $work/info.log
         if [ "$?" != "0" ]; then
             echo "FAIL: dcpinfo failed for $d"
             exit 1
@@ -104,17 +111,17 @@ if [ "$?" != "0" ]; then
     exit 1
 fi
 
-# Copy $private into build/ then re-write the subtitles of every DCP using
-# $work/rewrite_subs.  This tests round-trip of subtitle reading/writing.
-# Note that all the subs in $private/metadata are Interop.
+# Copy $private/metadata into build/metadata then re-write the subtitles
+# of every DCP using $work/rewrite_subs.  This tests round-trip of
+# subtitle reading/writing.
 rm -f $work/info2.log
 rm -rf $work/private
 mkdir $work/private
-cp -r $private/* $work/private
+cp -r $private/metadata $work/private/
 for d in `find $work/private/metadata -mindepth 1 -maxdepth 1 -type d | sort -f -d`; do
     if [ `basename $d` != ".git" ]; then
         $work/rewrite_subs $d
-        $dcpinfo --ignore-missing-assets -k -s $d >> $work/info2.log
+        $dcpinfo --ignore-missing-assets -s $d >> $work/info2.log
     fi
 done